/*========================================================================
    Copyright (C) 1999  Ing Krippel Harald
    E-Mail: neuro.harald@surfeu.at

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

========================================================================*/
#include <Application.h>
#include <String.h>

#include "MainWindow.h"
#include "MainView.h"
#include "evolut.h"


MainView	*aView;
char mytext[100]="Nix da";
int	myflag=0;

MainWindow::MainWindow(BRect frame)
				: BWindow(frame, "Hello", B_TITLED_WINDOW, B_NOT_ZOOMABLE )
{
	SetPulseRate(300);
	// set up a rectangle and instantiate a new view
	BRect aRect( Bounds() );
	aView = new MainView(aRect, "HelloView", "Hello World!");
	// add view to window
	AddChild(aView);
	
}

bool MainWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}

void MainView::Pulse()
{
	if( myflag == 1)
	{
		aView->SetText(mytext);
		myflag=0;
	}
}
long Do_Print(POPULATION *pop)
{
	char fname[256];
	
	if(pop->InitOK == TRUE)
	{	
		sprintf(mytext,"Generation: %ld Lernmuster %ld ente Lebe: %ld dim: %ld Error: %f"
					,pop->generation,lernmust,pop->rep->mutprob,pop->rep->mutdim,pop->rep->fitness);
		myflag=1;
		if(pop->rep->fitness <= ENDERR)			
			pop->inPause = TRUE;
		if(pop->rep->fitness <= STOPERROR)
		{
			cc= 1;
			STOPERROR = STOPERROR*faktor;
			if(lernmust < LERNMUSTMAX)
			{
				sprintf(fname,"%s/protokoll",path_string.String());
				Do_fPrint(pop,fname);
				sprintf(fname,"%s/Gehirn%ld",path_string.String(),pop->generation);
				save_daten(&pop->rep[0],fname);		
		    	lernmust+=ADDME;
		    	if(lernmust > LERNMUSTMAX)
		    		lernmust=LERNMUSTMAX;
			}
			else
			{
	//			STOPERROR = STOPERROR*faktor;
				sprintf(fname,"%s/protokoll",path_string.String());
				Do_fPrint(pop,fname);
				sprintf(fname,"%s/Gehirn%ld",path_string.String(),pop->generation);
				save_daten(&pop->rep[0],fname);		
			}
		}
	}
	return(0);
}
long Do_fPrint(POPULATION *pop, char *name)
{

 char	text[256];
 char	errorString[256];
 long 	a;
 long	i,k,l;
 //long xx=10,yy=70,dy=20;
 FILE	*fp;
// float	fehler,tolleranz;
 float  gesammt;

if(pop->InitOK == TRUE && pop->inUse == TRUE)
{
	if((fp=fopen(name,"a+"))!=NULL)
	{
		fprintf(fp,"\nGeneration %li \n",pop->generation);	// berschrift
		a=sprintf(errorString," Fehler: %f Lernmust: %ld  ",pop->rep->fitness,lernmust);
		fprintf(fp,"%s\n",errorString);
			gesammt=0;
			for(i=0;i < TESTMUSTMAX; i++)
			{
				fprintf(fp,"\nSoll%li:",i);				// Solldaten
				for(l=0;l<MAXOUT;l++)
				{
					a=sprintf(text," %2.2f ", undo_skal(oskalmin,oskalmax,
													pop->musterO[i+LERNMUSTMAX][l]));
					fprintf(fp,"%s",text);
				}
				for(k=0; k<MAXINP; k++)		// von 1 bis letzten input  Muster in Inputneuron schreiben
				{
					pop->rep->myrep->Neuronen[k].output = pop->musterI[i+LERNMUSTMAX][k];
				}

				probagation(i+LERNMUSTMAX,pop->rep,pop);		// Istdaten
				fprintf(fp,"     Ist :");
				for(l=0;l<MAXOUT;l++)
				{
					a=sprintf(text," %2.2f ", undo_skal(oskalmin,oskalmax,
								pop->rep->myrep->Neuronen[l+(NEURONANZ-MAXOUT)].output));
					fprintf(fp,"%s",text);
				}
				
			}
	fclose(fp);
	}
}
return(1);	// alles OK
}